<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Oasis3-MCT: mod_oasis_coupler Module Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Oasis3-MCT
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Data Types</a> &#124;
<a href="#func-members">Functions/Subroutines</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">mod_oasis_coupler Module Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Initialize the OASIS coupler infrastructure.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Data Types</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">type &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structmod__oasis__coupler_1_1prism__coupler__type.html">prism_coupler_type</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Coupler data for managing all aspects of coupling in OASIS.  <a href="structmod__oasis__coupler_1_1prism__coupler__type.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">type &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structmod__oasis__coupler_1_1prism__router__type.html">prism_router_type</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Router information for rearranging data on tasks.  <a href="structmod__oasis__coupler_1_1prism__router__type.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions/Subroutines</h2></td></tr>
<tr class="memitem:ab48c4d4ee118f948ccc286eec5b509ec"><td class="memItemLeft" align="right" valign="top">subroutine, public&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__coupler.html#ab48c4d4ee118f948ccc286eec5b509ec">oasis_coupler_setup</a> ()</td></tr>
<tr class="memdesc:ab48c4d4ee118f948ccc286eec5b509ec"><td class="mdescLeft">&#160;</td><td class="mdescRight">Main routine to setup couplers.  <a href="#ab48c4d4ee118f948ccc286eec5b509ec">More...</a><br /></td></tr>
<tr class="separator:ab48c4d4ee118f948ccc286eec5b509ec"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5cb96db0ae7b837db934689a49df3da6"><td class="memItemLeft" align="right" valign="top">subroutine&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__coupler.html#a5cb96db0ae7b837db934689a49df3da6">oasis_coupler_print</a> (cplid, pcprint)</td></tr>
<tr class="memdesc:a5cb96db0ae7b837db934689a49df3da6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Print routine for oasis_couplers.  <a href="#a5cb96db0ae7b837db934689a49df3da6">More...</a><br /></td></tr>
<tr class="separator:a5cb96db0ae7b837db934689a49df3da6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a65adf0558cfd9a9d316bd22ad1f9dc23"><td class="memItemLeft" align="right" valign="top">subroutine, public&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__coupler.html#a65adf0558cfd9a9d316bd22ad1f9dc23">oasis_coupler_bldvarname</a> (varid, varnum, vname)</td></tr>
<tr class="memdesc:a65adf0558cfd9a9d316bd22ad1f9dc23"><td class="mdescLeft">&#160;</td><td class="mdescRight">Build a consistent variable name based on bundles.  <a href="#a65adf0558cfd9a9d316bd22ad1f9dc23">More...</a><br /></td></tr>
<tr class="separator:a65adf0558cfd9a9d316bd22ad1f9dc23"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad8c9a74a349ea4420ac38e2da2dc3cd2"><td class="memItemLeft" align="right" valign="top">subroutine, public&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__coupler.html#ad8c9a74a349ea4420ac38e2da2dc3cd2">oasis_coupler_unbldvarname</a> (varid, vname, varnum)</td></tr>
<tr class="memdesc:ad8c9a74a349ea4420ac38e2da2dc3cd2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Deconstruct the varname based on oasis_coupler_bldvarname.  <a href="#ad8c9a74a349ea4420ac38e2da2dc3cd2">More...</a><br /></td></tr>
<tr class="separator:ad8c9a74a349ea4420ac38e2da2dc3cd2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a773e323d2275aff227e05e98ce97def1"><td class="memItemLeft" align="right" valign="top">subroutine&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__coupler.html#a773e323d2275aff227e05e98ce97def1">cplfind</a> (num, fldlist, fld, ifind, nfind)</td></tr>
<tr class="memdesc:a773e323d2275aff227e05e98ce97def1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Search a character field list for a matching values.  <a href="#a773e323d2275aff227e05e98ce97def1">More...</a><br /></td></tr>
<tr class="separator:a773e323d2275aff227e05e98ce97def1"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:a6f166f099a134dffba97a168d28a3c01"><td class="memItemLeft" align="right" valign="top">integer(kind=ip_i4_p), parameter, public&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__coupler.html#a6f166f099a134dffba97a168d28a3c01">prism_coupler_avsmax</a> =5</td></tr>
<tr class="memdesc:a6f166f099a134dffba97a168d28a3c01"><td class="mdescLeft">&#160;</td><td class="mdescRight">maximum number of higher order terms in mapping  <a href="#a6f166f099a134dffba97a168d28a3c01">More...</a><br /></td></tr>
<tr class="separator:a6f166f099a134dffba97a168d28a3c01"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6d46883e9df70ab9cdafaf607afacacb"><td class="memItemLeft" align="right" valign="top">integer(kind=ip_i4_p)&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__coupler.html#a6d46883e9df70ab9cdafaf607afacacb">prism_mrouter</a></td></tr>
<tr class="memdesc:a6d46883e9df70ab9cdafaf607afacacb"><td class="mdescLeft">&#160;</td><td class="mdescRight">max routers  <a href="#a6d46883e9df70ab9cdafaf607afacacb">More...</a><br /></td></tr>
<tr class="separator:a6d46883e9df70ab9cdafaf607afacacb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2ebdb255598e1b004de2533f16b06e04"><td class="memItemLeft" align="right" valign="top">integer(kind=ip_i4_p)&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__coupler.html#a2ebdb255598e1b004de2533f16b06e04">prism_nrouter</a> = 0</td></tr>
<tr class="memdesc:a2ebdb255598e1b004de2533f16b06e04"><td class="mdescLeft">&#160;</td><td class="mdescRight">router counter  <a href="#a2ebdb255598e1b004de2533f16b06e04">More...</a><br /></td></tr>
<tr class="separator:a2ebdb255598e1b004de2533f16b06e04"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a33dbf692ad73f83f73fe083e252badd8"><td class="memItemLeft" align="right" valign="top">type(<a class="el" href="structmod__oasis__coupler_1_1prism__router__type.html">prism_router_type</a>), dimension(:), pointer, public&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__coupler.html#a33dbf692ad73f83f73fe083e252badd8">prism_router</a></td></tr>
<tr class="memdesc:a33dbf692ad73f83f73fe083e252badd8"><td class="mdescLeft">&#160;</td><td class="mdescRight">prism_router array  <a href="#a33dbf692ad73f83f73fe083e252badd8">More...</a><br /></td></tr>
<tr class="separator:a33dbf692ad73f83f73fe083e252badd8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaa019c39b0f657e7c37820697ecf354a"><td class="memItemLeft" align="right" valign="top">integer(kind=ip_i4_p), public&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__coupler.html#aaa019c39b0f657e7c37820697ecf354a">prism_mcoupler</a></td></tr>
<tr class="memdesc:aaa019c39b0f657e7c37820697ecf354a"><td class="mdescLeft">&#160;</td><td class="mdescRight">max couplers  <a href="#aaa019c39b0f657e7c37820697ecf354a">More...</a><br /></td></tr>
<tr class="separator:aaa019c39b0f657e7c37820697ecf354a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae59d8823993d9ca8610efd9770393271"><td class="memItemLeft" align="right" valign="top">type(<a class="el" href="structmod__oasis__coupler_1_1prism__coupler__type.html">prism_coupler_type</a>), dimension(:), pointer, public&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__coupler.html#ae59d8823993d9ca8610efd9770393271">prism_coupler_put</a></td></tr>
<tr class="memdesc:ae59d8823993d9ca8610efd9770393271"><td class="mdescLeft">&#160;</td><td class="mdescRight">prism_coupler put array  <a href="#ae59d8823993d9ca8610efd9770393271">More...</a><br /></td></tr>
<tr class="separator:ae59d8823993d9ca8610efd9770393271"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a96df3ef2ec1b53597bb9beca43fe8349"><td class="memItemLeft" align="right" valign="top">type(<a class="el" href="structmod__oasis__coupler_1_1prism__coupler__type.html">prism_coupler_type</a>), dimension(:), pointer, public&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__coupler.html#a96df3ef2ec1b53597bb9beca43fe8349">prism_coupler_get</a></td></tr>
<tr class="memdesc:a96df3ef2ec1b53597bb9beca43fe8349"><td class="mdescLeft">&#160;</td><td class="mdescRight">prism_coupler get array  <a href="#a96df3ef2ec1b53597bb9beca43fe8349">More...</a><br /></td></tr>
<tr class="separator:a96df3ef2ec1b53597bb9beca43fe8349"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0cb9b8a96c10385d38fa244d920c7eaf"><td class="memItemLeft" align="right" valign="top">integer(kind=ip_i4_p), public&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__coupler.html#a0cb9b8a96c10385d38fa244d920c7eaf">lastseq</a></td></tr>
<tr class="memdesc:a0cb9b8a96c10385d38fa244d920c7eaf"><td class="mdescLeft">&#160;</td><td class="mdescRight">last coupler sequence  <a href="#a0cb9b8a96c10385d38fa244d920c7eaf">More...</a><br /></td></tr>
<tr class="separator:a0cb9b8a96c10385d38fa244d920c7eaf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a47f4727f94719892d837f6a1545d3d08"><td class="memItemLeft" align="right" valign="top">integer(kind=ip_i4_p), public&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__coupler.html#a47f4727f94719892d837f6a1545d3d08">lastseqtime</a></td></tr>
<tr class="memdesc:a47f4727f94719892d837f6a1545d3d08"><td class="mdescLeft">&#160;</td><td class="mdescRight">last coupler sequence time  <a href="#a47f4727f94719892d837f6a1545d3d08">More...</a><br /></td></tr>
<tr class="separator:a47f4727f94719892d837f6a1545d3d08"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab494fbbb8065f3a006892828f288e44a"><td class="memItemLeft" align="right" valign="top">logical, public&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemod__oasis__coupler.html#ab494fbbb8065f3a006892828f288e44a">allow_no_restart</a></td></tr>
<tr class="memdesc:ab494fbbb8065f3a006892828f288e44a"><td class="mdescLeft">&#160;</td><td class="mdescRight">flag to allow no restart files at startup  <a href="#ab494fbbb8065f3a006892828f288e44a">More...</a><br /></td></tr>
<tr class="separator:ab494fbbb8065f3a006892828f288e44a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Initialize the OASIS coupler infrastructure. </p>
</div><h2 class="groupheader">Function/Subroutine Documentation</h2>
<a id="a773e323d2275aff227e05e98ce97def1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a773e323d2275aff227e05e98ce97def1">&#9670;&nbsp;</a></span>cplfind()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">subroutine mod_oasis_coupler::cplfind </td>
          <td>(</td>
          <td class="paramtype">integer(in), intent(in)&#160;</td>
          <td class="paramname"><em>num</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">character(len=cl), dimension(:), intent(in)&#160;</td>
          <td class="paramname"><em>fldlist</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">character(len=cl), intent(in)&#160;</td>
          <td class="paramname"><em>fld</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">integer(in), intent(out)&#160;</td>
          <td class="paramname"><em>ifind</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">integer(in), intent(out)&#160;</td>
          <td class="paramname"><em>nfind</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Search a character field list for a matching values. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">num</td><td>size of array</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">fldlist</td><td>sorted field list</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">fld</td><td>field to search for</td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">ifind</td><td>first match index</td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">nfind</td><td>number that match </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="mod__oasis__coupler_8_f90_source.html#l02106">2106</a> of file <a class="el" href="mod__oasis__coupler_8_f90_source.html">mod_oasis_coupler.F90</a>.</p>

</div>
</div>
<a id="a65adf0558cfd9a9d316bd22ad1f9dc23"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a65adf0558cfd9a9d316bd22ad1f9dc23">&#9670;&nbsp;</a></span>oasis_coupler_bldvarname()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">subroutine, public mod_oasis_coupler::oasis_coupler_bldvarname </td>
          <td>(</td>
          <td class="paramtype">integer(ip_i4_p), intent(in)&#160;</td>
          <td class="paramname"><em>varid</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">integer(ip_i4_p), intent(in)&#160;</td>
          <td class="paramname"><em>varnum</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">character(len=*), intent(out)&#160;</td>
          <td class="paramname"><em>vname</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Build a consistent variable name based on bundles. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">varid</td><td>variable id</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">varnum</td><td>variable bundle level number</td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">vname</td><td>variable name </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="mod__oasis__coupler_8_f90_source.html#l02012">2012</a> of file <a class="el" href="mod__oasis__coupler_8_f90_source.html">mod_oasis_coupler.F90</a>.</p>

</div>
</div>
<a id="a5cb96db0ae7b837db934689a49df3da6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5cb96db0ae7b837db934689a49df3da6">&#9670;&nbsp;</a></span>oasis_coupler_print()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">subroutine mod_oasis_coupler::oasis_coupler_print </td>
          <td>(</td>
          <td class="paramtype">integer(ip_i4_p), intent(in)&#160;</td>
          <td class="paramname"><em>cplid</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">type(<a class="el" href="structmod__oasis__coupler_1_1prism__coupler__type.html">prism_coupler_type</a>), intent(in)&#160;</td>
          <td class="paramname"><em>pcprint</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Print routine for oasis_couplers. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">cplid</td><td>coupler id</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">pcprint</td><td>specific prism_coupler </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="mod__oasis__coupler_8_f90_source.html#l01904">1904</a> of file <a class="el" href="mod__oasis__coupler_8_f90_source.html">mod_oasis_coupler.F90</a>.</p>

</div>
</div>
<a id="ab48c4d4ee118f948ccc286eec5b509ec"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab48c4d4ee118f948ccc286eec5b509ec">&#9670;&nbsp;</a></span>oasis_coupler_setup()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">subroutine, public mod_oasis_coupler::oasis_coupler_setup </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Main routine to setup couplers. </p>
<p>This routine initializes all the coupler data based on the namcouple inputs and the calls into the OASIS initialization interfaces from models. It reconciles everything. This is called from oasis_enddef. </p>
<ul>
<li>Allocate and zero prism_router, prism_mapper, prism_coupler based on nnamcpl</li>
<li>Generate model variable lists across all models based on def_var calls. These will be reconciled with the namcouple input. These are sorted to improve search performance later.</li>
<li>Setup couplers based on namcouple and model variable info.</li>
<li>Preprocess namcouple strings and sort for faster searches</li>
<li>Loop over all my model variables<ul>
<li>Get parition and field information</li>
<li>Check if variable is In or Out and then find namcouple matches</li>
<li>Loop over the namcouple matches<ul>
<li>Migrate namcouple info into part</li>
<li>Make sure it's either an In or Out, sanity check</li>
<li>Determine matching field name from namcouple</li>
<li>Search for list of models with other variable</li>
<li>Loop over those other matching variable names<ul>
<li>Check that one side is In and other side is Out for communication</li>
<li>Check if input or output, field name should match on both sides.</li>
<li>Check that the bundle size matches in both models for bundled fields</li>
<li>Generate field list, multiple field support</li>
<li>Add this coupler to list of prism_var couplers</li>
<li>Copy namcouple settings into this coupler or check that coupler is consistent with prior setting</li>
<li>Set prism_coupler input and output flags</li>
<li>Setup prism_coupler router</li>
<li>Setup prism_coupler mapper</li>
<li>Try to reuse mapper already defined, must match mapping file and partition</li>
<li>Or get ready to initialize a new mapper</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li>Rebuild the fields list based on field bundles as needed</li>
<li>Initialize coupling infrastructure based on initial coupler setup above</li>
<li>Loop over all couplers<ul>
<li>Initialize avect1 which stores the get/put data</li>
<li>Compute nflds for this coupling and initialize avcnt and status</li>
<li>Initialize the mapper data</li>
<li>Read mapper mask and area if not already done</li>
<li>Initialize avect1m, the data in avect1 mapped to another grid</li>
<li>Initialize router based on rpartID</li>
</ul>
</li>
<li>Diagnostics for all couplers </li>
</ul>

<p class="definition">Definition at line <a class="el" href="mod__oasis__coupler_8_f90_source.html#l00121">121</a> of file <a class="el" href="mod__oasis__coupler_8_f90_source.html">mod_oasis_coupler.F90</a>.</p>

</div>
</div>
<a id="ad8c9a74a349ea4420ac38e2da2dc3cd2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad8c9a74a349ea4420ac38e2da2dc3cd2">&#9670;&nbsp;</a></span>oasis_coupler_unbldvarname()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">subroutine, public mod_oasis_coupler::oasis_coupler_unbldvarname </td>
          <td>(</td>
          <td class="paramtype">integer(ip_i4_p), intent(in)&#160;</td>
          <td class="paramname"><em>varid</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">character(len=*), intent(in)&#160;</td>
          <td class="paramname"><em>vname</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">integer(ip_i4_p), intent(out)&#160;</td>
          <td class="paramname"><em>varnum</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Deconstruct the varname based on oasis_coupler_bldvarname. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">varid</td><td>variable id</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">vname</td><td>variable name</td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">varnum</td><td>variable bundle level number </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="mod__oasis__coupler_8_f90_source.html#l02055">2055</a> of file <a class="el" href="mod__oasis__coupler_8_f90_source.html">mod_oasis_coupler.F90</a>.</p>

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a id="ab494fbbb8065f3a006892828f288e44a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab494fbbb8065f3a006892828f288e44a">&#9670;&nbsp;</a></span>allow_no_restart</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">logical, public mod_oasis_coupler::allow_no_restart</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>flag to allow no restart files at startup </p>

<p class="definition">Definition at line <a class="el" href="mod__oasis__coupler_8_f90_source.html#l00106">106</a> of file <a class="el" href="mod__oasis__coupler_8_f90_source.html">mod_oasis_coupler.F90</a>.</p>

</div>
</div>
<a id="a0cb9b8a96c10385d38fa244d920c7eaf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0cb9b8a96c10385d38fa244d920c7eaf">&#9670;&nbsp;</a></span>lastseq</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">integer(kind=ip_i4_p), public mod_oasis_coupler::lastseq</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>last coupler sequence </p>

<p class="definition">Definition at line <a class="el" href="mod__oasis__coupler_8_f90_source.html#l00104">104</a> of file <a class="el" href="mod__oasis__coupler_8_f90_source.html">mod_oasis_coupler.F90</a>.</p>

</div>
</div>
<a id="a47f4727f94719892d837f6a1545d3d08"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a47f4727f94719892d837f6a1545d3d08">&#9670;&nbsp;</a></span>lastseqtime</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">integer(kind=ip_i4_p), public mod_oasis_coupler::lastseqtime</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>last coupler sequence time </p>

<p class="definition">Definition at line <a class="el" href="mod__oasis__coupler_8_f90_source.html#l00105">105</a> of file <a class="el" href="mod__oasis__coupler_8_f90_source.html">mod_oasis_coupler.F90</a>.</p>

</div>
</div>
<a id="a6f166f099a134dffba97a168d28a3c01"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6f166f099a134dffba97a168d28a3c01">&#9670;&nbsp;</a></span>prism_coupler_avsmax</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">integer(kind=ip_i4_p), parameter, public mod_oasis_coupler::prism_coupler_avsmax =5</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>maximum number of higher order terms in mapping </p>

<p class="definition">Definition at line <a class="el" href="mod__oasis__coupler_8_f90_source.html#l00044">44</a> of file <a class="el" href="mod__oasis__coupler_8_f90_source.html">mod_oasis_coupler.F90</a>.</p>

</div>
</div>
<a id="a96df3ef2ec1b53597bb9beca43fe8349"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a96df3ef2ec1b53597bb9beca43fe8349">&#9670;&nbsp;</a></span>prism_coupler_get</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">type(<a class="el" href="structmod__oasis__coupler_1_1prism__coupler__type.html">prism_coupler_type</a>), dimension(:), pointer, public mod_oasis_coupler::prism_coupler_get</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>prism_coupler get array </p>

<p class="definition">Definition at line <a class="el" href="mod__oasis__coupler_8_f90_source.html#l00102">102</a> of file <a class="el" href="mod__oasis__coupler_8_f90_source.html">mod_oasis_coupler.F90</a>.</p>

</div>
</div>
<a id="ae59d8823993d9ca8610efd9770393271"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae59d8823993d9ca8610efd9770393271">&#9670;&nbsp;</a></span>prism_coupler_put</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">type(<a class="el" href="structmod__oasis__coupler_1_1prism__coupler__type.html">prism_coupler_type</a>), dimension(:), pointer, public mod_oasis_coupler::prism_coupler_put</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>prism_coupler put array </p>

<p class="definition">Definition at line <a class="el" href="mod__oasis__coupler_8_f90_source.html#l00101">101</a> of file <a class="el" href="mod__oasis__coupler_8_f90_source.html">mod_oasis_coupler.F90</a>.</p>

</div>
</div>
<a id="aaa019c39b0f657e7c37820697ecf354a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaa019c39b0f657e7c37820697ecf354a">&#9670;&nbsp;</a></span>prism_mcoupler</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">integer(kind=ip_i4_p), public mod_oasis_coupler::prism_mcoupler</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>max couplers </p>

<p class="definition">Definition at line <a class="el" href="mod__oasis__coupler_8_f90_source.html#l00100">100</a> of file <a class="el" href="mod__oasis__coupler_8_f90_source.html">mod_oasis_coupler.F90</a>.</p>

</div>
</div>
<a id="a6d46883e9df70ab9cdafaf607afacacb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6d46883e9df70ab9cdafaf607afacacb">&#9670;&nbsp;</a></span>prism_mrouter</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">integer(kind=ip_i4_p) mod_oasis_coupler::prism_mrouter</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>max routers </p>

<p class="definition">Definition at line <a class="el" href="mod__oasis__coupler_8_f90_source.html#l00096">96</a> of file <a class="el" href="mod__oasis__coupler_8_f90_source.html">mod_oasis_coupler.F90</a>.</p>

</div>
</div>
<a id="a2ebdb255598e1b004de2533f16b06e04"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2ebdb255598e1b004de2533f16b06e04">&#9670;&nbsp;</a></span>prism_nrouter</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">integer(kind=ip_i4_p) mod_oasis_coupler::prism_nrouter = 0</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>router counter </p>

<p class="definition">Definition at line <a class="el" href="mod__oasis__coupler_8_f90_source.html#l00097">97</a> of file <a class="el" href="mod__oasis__coupler_8_f90_source.html">mod_oasis_coupler.F90</a>.</p>

</div>
</div>
<a id="a33dbf692ad73f83f73fe083e252badd8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a33dbf692ad73f83f73fe083e252badd8">&#9670;&nbsp;</a></span>prism_router</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">type(<a class="el" href="structmod__oasis__coupler_1_1prism__router__type.html">prism_router_type</a>), dimension(:), pointer, public mod_oasis_coupler::prism_router</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>prism_router array </p>

<p class="definition">Definition at line <a class="el" href="mod__oasis__coupler_8_f90_source.html#l00098">98</a> of file <a class="el" href="mod__oasis__coupler_8_f90_source.html">mod_oasis_coupler.F90</a>.</p>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Jun 29 2018 20:52:29 for Oasis3-MCT by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
